StorageConverter = class()
StorageConverter.converterFunctions = nil

local function toV1(data)
    local newData = {
        colourMap = {},
        vertices = {},
        edges = {}
    }

    for vertexId, colour in pairs(data.colourMap) do
        newData.colourMap[vertexId] = colour
    end

    for _, vertex in pairs(data.nodes) do
        table.insert(newData.vertices, vertex)
    end

    for _, edge in ipairs(data.edges) do
        local newEdge = {
            source = edge.outgoing,
            destination = edge.incoming
        }

        table.insert(newData.edges, newEdge)
    end

    return newData
end

function StorageConverter:init()
    self.converterFunctions = List()
    self.converterFunctions:add(toV1)
end

function StorageConverter:upgradeData(data, currentVersion, targetVersion)
    sm.log.info(("Upgrading storage file.\nCurrent version: %i\nTarget version: %i"):format(currentVersion, targetVersion))

    for i = currentVersion + 1, targetVersion, 1 do
        data = self.converterFunctions:getAt(i)(data)
        sm.log.info(("Current upgrade %i"):format(i))
    end

    return data
end
