StorageManager = class()
StorageManager.VERSION = 1
StorageManager.jsonPath = nil
StorageManager.jsonFile = nil
StorageManager.scriptedShape = nil
StorageManager.ingameStorage = nil

function StorageManager:init(scriptedShape, ingameStorage, jsonPath, jsonFile)
    self.version = StorageManager.VERSION
    self.scriptedShape = scriptedShape
    self.ingameStorage = ingameStorage
    self.jsonPath = jsonPath
    self.jsonFile = jsonFile
end

function StorageManager:getJsonPath()
    return self.jsonPath
end

function StorageManager:getJsonFile()
    return self.jsonFile
end

function StorageManager:saveToWorld(data)
    self.ingameStorage:save(data)
end

function StorageManager:loadFromWorld()
    if self.scriptedShape:server_hasStoredData() then
        local data = self.ingameStorage:load()
        data = StorageConverter():upgradeData(data, data.version or 0, self.version)

        return data
    end
end

function StorageManager:saveToJsonFile(data)
    local finalPath = string.format("$MOD_DATA/%s/%s", self.jsonPath, self.jsonFile)
    sm.json.save(data, finalPath)
end

function StorageManager:loadFromJsonFile()
    local finalPath = string.format("$MOD_DATA/%s/%s", self.jsonPath, self.jsonFile)
    local data = sm.json.open(finalPath)

    return data
end
