dofile("../Include.lua")

GateTagger = class(ScriptedShape)
GateTagger.connectionInput = sm.interactable.connectionType.none
GateTagger.connectionOutput = sm.interactable.connectionType.none
GateTagger.nameTag = nil
GateTagger.enabled = nil

function GateTagger:init()
    ScriptedShape.init(self)
    self.enabled = false
end

function GateTagger:server_onCreate()
    ScriptedShape.server_onCreate(self)
end

function GateTagger:server_onDestroy()
    ScriptedShape.server_onDestroy(self)
end

function GateTagger:server_onFixedUpdate(deltaTime)
    ScriptedShape.server_onFixedUpdate(self, deltaTime)
end

function GateTagger:client_canInteract()
    sm.gui.setInteractionText("Use", sm.gui.getKeyBinding("Use"), "to toggle name tag visibility")

    return true
end

function GateTagger:client_onInteract(character, looksAtPart)
    if looksAtPart then
        self.enabled = not self.enabled
        _G.gtEnabled = self.enabled

        if self.enabled then
            self.nameTag:open()
        else
            self.nameTag:close()
        end

        local enabledText = self.enabled and "enabled" or "disabled"
        sm.gui.displayAlertText(string.format("Name tag visibility %s", enabledText))
    end
end

function GateTagger:client_onCreate()
    self.nameTag = sm.gui.createNameTagGui()
    self.nameTag:setWorldPosition(self.shape:getWorldPosition() + sm.vec3.new(0, 0, 0.25))
    self.nameTag:setRequireLineOfSight(false)
    self.nameTag:setMaxRenderDistance(10)
    _G.gtEnabled = _G.gtEnabled or false
end

function GateTagger:client_onDestroy()
    self.nameTag:destroy()
    _G.gtEnabled = false
    sm.gui.displayAlertText("A gate tagger has been destroyed. Disabling name tags.")
end

function GateTagger:client_onFixedUpdate(deltaTime)
    if self.enabled then
        local success, result = sm.localPlayer.getRaycast(5)
        local nameTagText

        if result.valid and result.type == "body" then
            local shape = result:getShape()

            if tostring(shape:getShapeUuid()) == "9f0f56e8-2c31-4d83-996c-d00a9b296c3f" then
                self.nameTag:setWorldPosition(shape:getWorldPosition() + sm.vec3.new(0, 0, 0.25))
                nameTagText = shape:getInteractable():getId()
            end
        end

        self:client_setNameTagText(nameTagText)
    end
end

function GateTagger:client_setNameTagText(text)
    local formattedText = string.format("#FFFFFF%s", text or "")
    self.nameTag:setText("Text", formattedText)
end
